Func:: Error(Message As String) ~~ Address: @uc_Raise_Error
Func:: ucAddr(index) ~~ Address: @uc_Func_ucAddr
Func:: SpecialArg(Value As Dword) ~~ Address: @uc_Func_SpecialArg
Func:: ValueAtAddr(DataType As Dword, Address As Dword, Index As Long = 0) ~~ Address: @uc_Func_ValueAtAddr
Syntax: ValAtAddr({name} [, {index=0}]) ::= ValueAtAddr(DataType({name}), Address({name}), {index})

Const: NullStr As String At @uc_NullString
Func: _Null(x As OmniType = '') As OmniType = x
Func:: uCalc(Command As Long, TextArg As String = NullStr, MiscArg1 As Long = 0, _
          MiscArg2 As Long = 0, ReturnPtr As Long = 0, t As Long = ~t) As Dword ~~ Address: @uc_Func_uCalc
Func:: uCalcVoid(Command As Long, TextArg As String = NullStr, MiscArg1 As Long = 0, _
          MiscArg2 As Long = 0, ReturnPtr As Long = 0, t As Long = ~t) As Void ~~ Address: @uc_Func_uCalc
Func:: uCalcStr(Command As Long, TextArg As String = NullStr, MiscArg1 As Long = 0, _
          MiscArg2 As Long = 0, ReturnPtr As Long = 0, t As Long = ~t) As String ~~ Address: @uc_Func_uCalcStr

Func: Precedence(Item As String, t As Long = ~t) = uCalc(uc_GetItemData, Item, 0, uc_Precedence, 0, t)

Func:: uc_Loop(ByExpr DoCondition, ByExpr Expression As AnyType, ByExpr LoopCondition)  As Void ~~ Address: @uc_Func_Loop
Func:: uc_For(ByHandle Counter As AnyType, Start, Finish, Step, ByExpr Expr As AnyType) As Void ~~ Address: @uc_Func_For

Func:: IfElseIf(ByExpr cond, ByExpr Expr ...) As Void ~~ Address: @uc_Func_If_ElseIf

Func:: uc_IsIncomplete(t As Long = ~t, Toggle As Long = 2) As Long ~~ Address: @uc_Func_IsIncomplete
Func:: uc_Peek(Address As Dword, Count As Long)  As String ~~ Address: @uc_Func_Peek
Func:: uc_Poke(Address As Dword, Text As String) As Void   ~~ Address: @uc_Func_Poke
Func:: ExprHandle(ByHandle Item As AnyType) As Dword       ~~ Address: @uc_Func_ExprHandle
Func:: VarPtr(Item As AnyType) As Dword                    ~~ Address: @uc_Func_VarPtr
# StrPtr defined in Strings.h

Func:: LoadLibrary(FileName As String) As Dword ~~ Address: @uc_Func_LoadLibrary
Func:: GetProcAddress(hModule As Dword, ProcName As String) As Dword ~~ Address: @uc_Func_GetProcAddress

Func:: uc_Count(StackName   As Stack) As Long ~~ Address: @uc_Func_Count_Stack
Func:: uc_Push(StackName As Stack, ByHandle Data As AnyType, Index As Long = 0) As Void ~~ Address: @uc_Func_PushData_Stack
Func:: uc_PushH(StackName As Stack, Handle As Dword, Index As Long=0, Reserved=0) As Void ~~ Address: @uc_Func_PushData_Stack
Func:: uc_PopNum(StackName  As Stack, Index = 0) As Extended ~~ Address: @uc_Func_PopNum_Stack
Func:: uc_PopStr(StackName  As Stack, Index = 0) As String   ~~ Address: @uc_Func_PopStr_Stack
Func:: uc_ReadNum(StackName As Stack, Index = 0) As Extended ~~ Address: @uc_Func_ReadNum_Stack
Func:: uc_ReadStr(StackName As Stack, Index = 0) As String   ~~ Address: @uc_Func_ReadStr_Stack
Func:: uc_ReadHandle(StackName As Stack, Index = 0) As Dword ~~ Address: @uc_Func_ReadHandle_Stack
Syntax: StackItemValue({var}, {index}) ::= _
        ValueAtAddr(hDataType(uc_ReadHandle({var}, {index})), hAddress(uc_ReadHandle({var}, {index}))) + _Null()

Func:: uc_Count(ListName As SortedList) As Long ~~ Address: @uc_Func_Count_Stack
Func:: uc_Index(ListName As SortedList, Text As String) As Long ~~ Address: @uc_Index_Table
Func:: uc_Insert(ListName As SortedList, Text As String) As Void ~~ Address: @uc_Insert_Table
Func:: uc_Delete(ListName As SortedList, Text As String) As Void ~~ Address: @uc_Delete_Table
Func:: uc_ReadStr(ListName As SortedList, Index = 0) As String ~~ Address: @uc_Func_ReadStr_Stack

Func:: uc_Count(TableName As Table) As Long ~~ Address: @uc_Func_Count_Stack
Func:: uc_Index(TableName As Table, Text As String) As Long ~~ Address: @uc_Index_Table
Func:: uc_Insert(TableName As Table, Entry As String, ByHandle Data As AnyType) As Void ~~ Address: @uc_Insert_Table
Func:: uc_Delete(TableName As Table, Entry As String) As Void ~~ Address: @uc_Delete_Table
Func:: uc_ReadKey(TableName As Table, Index = 0) As String ~~ Address: @uc_Func_ReadStr_Stack
Func:: uc_ReadData(TableName As Table, Key As String) As String ~~ Address: @uc_ReadData_Table
Func:: Handle(TableName As Table, Entry As String) As Dword ~~ Address: @uc_Handle_Table

Func: ucDefine(Def As String, t As Long = ~t) As Dword = uCalc(uc_Define, Def, 0, 0, 0, t)
Func: ucParse(Expr As String, Type As Dword = 0, t As Long = ~t) = uCalc(uc_Parse, Expr, Type, 0, 0, t)
Func: ucEvalStr(Expr As String, t As Long = ~t) As String = uCalcStr(uc_EvalStr, Expr, 0, 0, 0, t)
Func: ucEvaluateStr(ExprHandle, t As Long = ~t) As String = uCalcStr(uc_EvaluateStr, "", ExprHandle, 0, 0, t)
Func: ucExpand(Expr As String, t As Long = ~t) As String = uCalcStr(uc_Expand, Expr, 0, 0, 0, t)
Func: ucSteps(Expr As String, cr_count As Long = 1, t As Long = ~t) As String = uCalcStr(uc_Expand, Expr, 1, cr_count, 0, t)
Syntax: ucEval ::= ucEvalStr
Syntax: ucEvaluate ::= ucEvaluateStr

Syntax: Local([{' +'}]{Variable:'[^=, ]+'}[{etc}], {Expr}) ::= ~TempDef(Var: {Variable} {etc}) {Expr} ~Eval_P(ucRename({q}{Variable}{q}, {ns}))
Syntax: Local({Variable1}, {OtherVariables}, {Expr}) ::= Local({Variable1}, Local({OtherVariables}, {Expr}))

Func:: SetSyntaxParams(Parameters As String, Expr As String, t As Long = ~t) As String ~~ Address: @uc_Func_SetSyntaxParams
Syntax: Macro[([Pass] {pass})]: {name} [{args:'\([^\)]*\)'}] = [{replacement}] ::= _
        {pass: Pass: {pass} ~~} Syntax: ~Eval(SetSyntaxParams({q}{args}{q}, {q}{name}{args} ::= {replacement}{q}))

Func: ucHandle(Item As String, t As Long = ~t) As Dword = uCalc(-uc_GetItemData, Item, 0, uc_Handle, 0, t)
Func: ucRename(OldName As String, NewName As String, t As Long = ~t) As Void = _
      uCalcVoid(uc_SetItemData, NewName, ucHandle(OldName), uc_SymbolName, 0, t)
Func: ucRelease(ItemName As String, t As Long = ~t) As Void = uCalcVoid(uc_ReleaseItem, '', ucHandle(ItemName), 0, 0, t)
Func: ucRelease(Item) As Void = uCalcVoid(uc_ReleaseItem, '', Item)

Syntax: Address({Item}  [, {t=~t}])  ::= ~Eval(uCalc(uc_GetItemData, {q}{Item}{q}, 0, uc_Address,  0, {t}))
Syntax: DataType({Item} [, {t=~t}])  ::= ~Eval(uCalc(uc_GetItemData, {q}{Item}{q}, 0, uc_DataType, 0, {t}))
Syntax: hAddress({Item})  ::= ~Eval(uCalc(uc_GetItemData, {ns}, {Item}, uc_Address))
Syntax: hDataType({Item}) ::= ~Eval(uCalc(uc_GetItemData, {ns}, {Item}, uc_DataType))
Func: _Type(Item As Dword) = uCalc(uc_GetItemData, "", Item, uc_DataType)

# Assign Value to Variable (or allows modification of constant in the case of SetConst)
Func:: SetVar(ByHandle MyVar As AnyType,  ByHandle Value As AnyType)  As Void ~~ Address: @uc_SetVariableValueAnyType
Func:: SetVar(ByHandle MyVar As AnyType,  ByHandle Value As String)   As Void ~~ Address: @uc_SetVariableValueAnyType
Func:: SetVar(ByHandle MyVar As AnyType,  ByHandle Value As Extended) As Void ~~ Address: @uc_SetVariableValueAnyType
Func:: SetVar(ByHandle MyVar As Dword,    ByHandle Value As Dword)    As Void ~~ Address: @uc_SetVariableValueLong
Func:: SetVar(ByHandle MyVar As Long,     ByHandle Value As Long)     As Void ~~ Address: @uc_SetVariableValueLong
Func:: SetVar(ByHandle MyVar As Double,   ByHandle Value As Double)   As Void ~~ Address: @uc_SetVariableValueDouble
Func:: SetVar(ByHandle MyVar As Extended, ByHandle Value As Extended) As Void ~~ Address: @uc_SetVariableValueExtended
Func:: ResetVariable(ByHandle MyVar As AnyType) As Void ~~ Address: @uc_ResetVariable
Func:: GenericConvert(ByHandle MyVar As AnyType, ByHandle Value As AnyType) As Void _
       ~~ Address: @uc_SetVariableValueAnyType
Func:: SetConst_(ByHandle MyConst As AnyType, ByHandle Value As AnyType, IsConst) As Void _
       ~~ Address: @uc_SetVariableValueAnyType
Syntax: SetConst({Const}, {Value}) ::= SetConst_({Const}, {Value}, 1)

Const: True As Boolean ~~ Address: @uc_True
Const: False As Boolean = 0
Const: ucScriptTimerStart As Dword ~~ Address: @uc_ScriptTimerStart
