Const: User32   As Long = LoadLibrary("User32.DLL")
Const: Kernel32 As Long = LoadLibrary("Kernel32.DLL")
Const: OleAut32 As Long = LoadLibrary("OleAut32.DLL")
Const: Shlwapi  As Long = LoadLibrary("shlwapi.dll")
Const: GDI32    As Long = LoadLibrary("GDI32.dll")
Const: Shell32  As Long = LoadLibrary("Shell32.dll")

Const: FILE_TYPE_DISK = 1
Const: FILE_TYPE_CHAR = 2
Const: FILE_TYPE_PIPE = 3

Const: FILE_BEGIN   = 0
Const: FILE_CURRENT = 1
Const: FILE_END     = 2

Const: FILE_SHARE_READ   = 1
Const: FILE_SHARE_WRITE  = 2
Const: FILE_SHARE_DELETE = 4

Const: CREATE_NEW        = 1
Const: CREATE_ALWAYS     = 2
Const: OPEN_EXISTING     = 3
Const: OPEN_ALWAYS       = 4
Const: TRUNCATE_EXISTING = 5

Const: FILE_ATTRIBUTE_NORMAL = #h00000080 

Const: GENERIC_READ    = #h80000000
Const: GENERIC_WRITE   = #h40000000
Const: GENERIC_EXECUTE = #h20000000
Const: GENERIC_ALL     = #h10000000

Func: GetCommandLine() As Dword At GetProcAddress(Kernel32, "GetCommandLineA")
Func: GetLastError() As Long At GetProcAddress(Kernel32, "GetLastError")
Func: GetTickCount() As Dword At GetProcAddress(Kernel32, "GetTickCount")
Func: Sleep(ByVal dwMilliseconds As Dword) As Void At GetProcAddress(Kernel32, "Sleep")

Func: FindWindow(ByVal lpClassName As Dword, ByRef lpWindowName As LPCSTR) As Long _
      At GetProcAddress(User32, "FindWindowA")

Func: MessageBox(ByVal hWnd As Dword, ByRef lpText As LPCSTR, _
      ByRef lpCaption As LPCSTR, ByVal uType as Dword)        _
      As Long At GetProcAddress(User32, "MessageBoxA")

Func: PostMessage(ByVal Hwnd As Long, ByVal dwMsg As Long, _
      ByVal wParam As Long, ByVal lParam As Long) As Long  _
      At GetProcAddress(User32, "PostMessageA")

Func: SendMessage(ByVal Hwnd As Long, ByVal dwMsg As Long, _
      ByVal wParam As Long, ByVal lParam As Long) As Long  _
      At GetProcAddress(User32, "SendMessageA")

Func: SetForegroundWindow(ByVal hWnd As Dword) As Long _
      At GetProcAddress(User32, "SetForegroundWindow")

Func: ShellExecute(ByVal hwnd As Dword, ByRef lpOperation As LPCSTR, _
      ByRef lpFile As LPCSTR, ByRef lpParameters As LPCSTR,          _
      ByRef lpDirectory As LPCSTR, ByVal nShowCmd As Long) As Dword  _
      At GetProcAddress(Shell32, "ShellExecuteA")

# File handling
Func: CreateFile(ByRef lpFileName As LPCSTR, ByVal dwDesiredAccess As Dword,     _
      ByVal dwShareMode As Dword, ByVal lpSecurityAttributes As Dword,           _
      ByVal dwCreationDisposition As Dword, ByVal dwFlagsAndAttributes As Dword, _
      ByVal hTemplateFile As Dword) As Dword At GetProcAddress(Kernel32, "CreateFileA")

Func: CloseHandle(ByVal hObject As Dword) As Long At GetProcAddress(Kernel32, "CloseHandle")

Func: GetFileSize(ByVal hFile As Dword, ByVal lpFileSizeHigh As Dword) As Long _
      At GetProcAddress(Kernel32, "GetFileSize")

Func: MoveWindow(ByVal hWnd As Dword, ByVal x As Long, ByVal y As Long,            _
      ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long _
      At GetProcAddress(User32, "MoveWindow")

Func: SetFilePointer(ByVal hFile As Dword, ByVal lDistanceToMove As Long, _
      ByVal lpDistanceToMoveHigh As Dword, ByVal dwMoveMethod As Dword) As Long _
      At GetProcAddress(Kernel32, "SetFilePointer")

Func: ReadFile(ByVal hFile As Dword, ByRef lpBuffer As LPCSTR,               _
      ByVal nNumberOfBytesToRead As Long, ByRef lpNumberOfBytesRead As Long, _
      ByVal Ignore As Long) As Long At GetProcAddress(Kernel32, "ReadFile")

Func: WriteFile(ByVal hFile As Dword,                _
      ByRef lpBuffer As LPCSTR,                      _
      ByVal nNumberOfCharsToWrite As Long,           _
      ByRef lpNumberOfCharsWritten As Long,          _
      ByVal Ignore As Long) As Long                  _
      At GetProcAddress(Kernel32, "WriteFile")